石子合并(区间dp)

石子合并不应该是个区间dp?

题目:There is an old stone game.At the beginning of the game the player picks n(1<=n<=50000) piles of stones in a line. The goal is to merge the stones in one pile observing the following rules:
At each step of the game,the player can merge two adjoining piles to a new pile.The score is the number of stones in the new pile.
You are to write a program to determine the minimum of the total score.

Input

The input contains several test cases. The first line of each test case contains an integer n, denoting the number of piles. The following n integers describe the number of stones in each pile at the beginning of the game.
The last test case is followed by one zero.

Output

For each test case output the answer on a single line.You may assume the answer will not exceed 1000000000.

Sample Input

1
100
3
3 4 3
4
1 1 1 1
0

Sample Output

0
17
8

n<=50000都把我看蒙了,结果一查题解是GarsiaWachs算法??

算了,就当我先没看到数据量.

和前几天讲到的能量项链做法基本类似,这个要更简单一些,因为它是个线性dp,不是个环.

#include<iostream>
#include<algorithm>
#include<cstring>
using namespace std;
int n;
int a[10000];
int sum[10000][10000];
int dp[10000][10000];
int main()
{
    while(cin>>n)
    {
        if(n==0)
            break;
        for(int i=1; i<=n; i++)
        {
            cin>>a[i];
        }
        if(n==1)
        {
            cout<<0<<endl;
            continue;
        }
        memset(dp,9999999,sizeof(dp));
        for(int i=1; i<=n; i++)
        {
            sum[i][i]=a[i];
            dp[i][i]=0;
            for(int j=i+1; j<=n; j++)
            {
                sum[i][j]=sum[i][j-1]+a[j];
            }
        }
        for(int i=2; i<=n; i++)
        {
            for(int j=1; j<=n-i+1; j++)
            {
                int p=j+i-1;
                for(int k=j; k<=p-1; k++)
                {
                    dp[j][p]=min(dp[j][p],dp[j][k]+dp[k+1][p]+sum[j][p]);
                }
            }

        }
        cout<<dp[1][n]<<endl;
        memset(sum,0,sizeof(sum));
    }
    return 0;
}

原文地址:https://www.cnblogs.com/iloveysm/p/12359137.html

时间: 2024-10-24 07:37:15

石子合并(区间dp)的相关文章

石子合并 区间dp模板

题意:中文题 Description 在操场上沿一直线排列着 n堆石子.现要将石子有次序地合并成一堆.规定每次只能选相邻的两堆石子合并成新的一堆, 并将新的一堆石子数记为该次合并的得分.允许在第一次合并前对调一次相邻两堆石子的次序. 计算在上述条件下将n堆石子合并成一堆的最小得分. Input 输入数据共有二行,其中,第1行是石子堆数n≤100:第2行是顺序排列的各堆石子数(≤20),每两个数之间用空格分隔. Output 输出合并的最小得分. Sample Input 3 2 5 1 Samp

石子合并 区间DP模板题

题目链接:https://vjudge.net/problem/51Nod-1021 题意 N堆石子摆成一条线.现要将石子有次序地合并成一堆.规定每次只能选相邻的2堆石子合并成新的一堆,并将新的一堆石子数记为该次合并的代价.计算将N堆石子合并成一堆的最小代价. 例如:1 2 3 4 ,有不少合并方法 1 2 3 4 => 3 3 4(3) => 6 4(9) => 10(19) 1 2 3 4 => 1 5 4(5) => 1 9(14) => 10(24) 1 2 3

HDU 3506 (环形石子合并)区间dp+四边形优化

Monkey Party Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 131072/65536 K (Java/Others)Total Submission(s): 1699    Accepted Submission(s): 769 Problem Description Far away from our world, there is a banana forest. And many lovely monkeys l

『字符合并 区间dp 状压dp』

字符合并 Description 有一个长度为 n 的 01 串,你可以每次将相邻的 k 个字符合并,得到一个新的字符并获得一定分数.得到的新字符和分数由这 k 个字符确定.你需要求出你能获得的最大分数. Input Format 第一行两个整数n,k.接下来一行长度为n的01串,表示初始串. 接下来2^k行,每行一个字符ci和一个整数wi,ci表示长度为k的01串连成二进制后按从小到大顺序得到的第i种合并方案得到的新字符,wi表示对应的第i种方案对应获得的分数. 1<=n<=300,0<

合并石子 (区间dp+前缀和)

[题目描述] N堆石子.现要将石子有次序地合并成一堆.规定每次只能选相邻的2堆石子合并成新的一堆,并将新的一堆石子数记为该次合并的得分.计算出将N堆石子合并成一堆的最小得分. [题目链接] http://ybt.ssoier.cn:8088/problem_show.php?pid=1274 [算法] 若每一步决策采用贪心,则所作出的决策具有后效性,故采用动态规划.考虑决策序列,dp[i][j]表示合并i到j堆石子最少得分,状态转移方程是dp[i][j]=min(dp[i][k]+dp[k+1]

蓝桥杯:合并石子(区间DP+平行四边形优化)

http://lx.lanqiao.cn/problem.page?gpid=T414 题意:…… 思路:很普通的区间DP,但是因为n<=1000,所以O(n^3)只能拿90分.上网查了下了解了平行四边形优化:地址. 但是看不懂. 1 #include <bits/stdc++.h> 2 using namespace std; 3 typedef long long LL; 4 const LL INF = 100000000000000000LL; 5 LL dp[1010][101

台州 OJ 2793 石子归并 区间DP

描述 有n堆石子排成一条直线,每堆石子有一定的重量.现在要合并这些石子成为一堆石子,但是每次只能合并相邻的两堆.每次合并需要消耗一定的体力,该体力为所合并的两堆石子的重量之和.问最少需要多少体力才能将n堆石子合并成一堆石子? 输入 输入只包含若干组数据.每组数据第一行包含一个正整数n(2<=n<=100),表示有n堆石子.接下来一行包含n个正整数a1,a2,a3,...,an(0<ai<=100,1<=i<=n). 输出 对应输入的数据,每行输出消耗的体力. dp[i]

2017.8.15 [Haoi2016]字符合并 区间dp+状压dp

[题目描述] 有一个长度为n的01串,你可以每次将相邻的k个字符合并,得到一个新的字符并获得一定分数.得到的新字符和分数由这k个字符确定.你需要求出你能获得的最大分数. [输入格式] 第一行两个整数n,k. 接下来一行长度为n的01串,表示初始串.输入的的相邻字符之间用一个空格隔开. 接下来2k行,每行一个字符ci和一个整数wi,ci表示长度为k的01串连成二进制后按从小到大顺序得到的第i种合并方案得到的新字符, wi表示对应的第i种方案对应获得的分数. [输出格式] 输出一个整数表示答案. [

合并石子,区间dp

#define INF 9999999 int n,a[99999],dp[9999][9999],ans=9999999,s[9999]; int main() { scanf("%d",&n); for(int i=1;i<=n;i++) scanf("%d",&a[i]),a[n+i]=a[i],s[i]=s[i-1]+a[i]; for(int i=1;i<n;i++) for(int j=1;j<=n-i;j++) { d